import { computed, inject, provide } from 'vue';
var TriggerContextKey = Symbol('TriggerContextKey');
export var useProviderTrigger = function useProviderTrigger() {
  var portal = null;
  provide(TriggerContextKey, {
    setPortal: function setPortal(val) {
      portal = val;
    },
    popPortal: true
  });
  return function () {
    return portal;
  };
};
export var useInjectTrigger = function useInjectTrigger() {
  return inject(TriggerContextKey, {
    setPortal: function setPortal() {},
    popPortal: false
  });
};
var PortalContextKey = Symbol('PortalContextKey');
export var useProvidePortal = function useProvidePortal(instance) {
  provide(PortalContextKey, {
    inTriggerContext: true,
    shouldRender: computed(function () {
      var sPopupVisible = instance.sPopupVisible,
          popupRef = instance.popupRef,
          forceRender = instance.forceRender,
          autoDestroy = instance.autoDestroy; // if (popPortal) return true;

      var shouldRender = false;

      if (sPopupVisible || popupRef || forceRender) {
        shouldRender = true;
      }

      if (!sPopupVisible && autoDestroy) {
        shouldRender = false;
      }

      return shouldRender;
    })
  });
};
export var useInjectPortal = function useInjectPortal() {
  var portalContext = inject(PortalContextKey, {
    shouldRender: computed(function () {
      return false;
    }),
    inTriggerContext: false
  });
  return {
    shouldRender: computed(function () {
      return portalContext.shouldRender.value || portalContext.inTriggerContext === false;
    })
  };
};